CREATE SCHEMA ManyToMany;
GO

CREATE TABLE ManyToMany.Companies (
  CompanyID int,
  CompanyName nvarchar(15) COLLATE Cyrillic_General_CI_AS NOT NULL,
  CONSTRAINT PK_Companies PRIMARY KEY (CompanyID)
)
GO

CREATE TABLE ManyToMany.Factories (
  FactoryID int,
  FactoryName nvarchar(15) COLLATE Cyrillic_General_CI_AS NOT NULL,
  FactoryAddress nvarchar(60) COLLATE Cyrillic_General_CI_AS NULL,
  FactoryCity nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  FactoryRegion nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  FactoryPostalCode nvarchar(10) COLLATE Cyrillic_General_CI_AS NULL,
  FactoryCountry nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  WorkersCount int,
  CONSTRAINT PK_Factories PRIMARY KEY (FactoryID)
)
GO

CREATE TABLE ManyToMany.Shops (
  ShopID int,
  ShopName nvarchar(15) COLLATE Cyrillic_General_CI_AS NOT NULL,
  ShopAddress nvarchar(60) COLLATE Cyrillic_General_CI_AS NULL,
  ShopCity nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  ShopRegion nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  ShopPostalCode nvarchar(10) COLLATE Cyrillic_General_CI_AS NULL,
  ShopCountry nvarchar(15) COLLATE Cyrillic_General_CI_AS NULL,
  CONSTRAINT PK_Shops PRIMARY KEY (ShopID)
)
GO

CREATE TABLE ManyToMany.CompanyFactories (
  CompanyID int NOT NULL,
  FactoryID int NOT NULL,
  PRIMARY KEY (CompanyID, FactoryID),
  FOREIGN KEY (CompanyID) REFERENCES ManyToMany.Companies (CompanyID),
  FOREIGN KEY (FactoryID) REFERENCES ManyToMany.Factories (FactoryID)
)
GO

CREATE TABLE ManyToMany.CompanyShops (
  CompanyID int NOT NULL,
  ShopID int NOT NULL,
  PRIMARY KEY (CompanyID, ShopID),
  FOREIGN KEY (CompanyID) REFERENCES ManyToMany.Companies (CompanyID),
  FOREIGN KEY (ShopID) REFERENCES ManyToMany.Shops (ShopID)
)
GO